
{% macro ship_to_billing_address_checkbox() %}
    <div class="custom-checkbox" id="same-as-billing-wrap">
        <input type="checkbox" name="same_as_billing" id="same_as_billing" value="1"{% if request.POST.get("same_as_billing") %} checked{% endif %}>
        <label for="same_as_billing">{% trans %}Ship to my billing address{% endtrans %}</label>
    </div>
{% endmacro %}

{% macro address_phase_billing_well(billing_form, company_form=None, saved_address_form=None) %}
    <div class="well">
        <fieldset>
            {{ render_address_form(_("Billing address"), billing_form, "billing", True) }}
            {% if company_form and xtheme.allow_company_linkage() %}
                {{ render_company_form(
                    _("Ordering for a company?"),
                    _("Please fill out these fields if you are ordering for a company."),
                    company_form.name, company_form.tax_number) }}
            {% endif %}
        </fieldset>
    </div>
{% endmacro %}

{% macro address_phase_shipping_well(shipping_form, ship_to_billing_checkbox=True, saved_address_form=None) %}
    <div class="well hidden" id="shipping-address">
        <fieldset>
            {{ render_address_form(_("Shipping address"), shipping_form, "shipping") }}
        </fieldset>
    </div>
{% endmacro %}


{% macro address_phase_extrajs() %}
    <script type="text/javascript">
        $(function(){
            var shouldCopyFields = false;

            function toggleAndCopyFields() {
                shouldCopyFields = $("#same_as_billing").is(":checked");

                if (shouldCopyFields) {
                    $("#shipping-address").addClass("hidden");

                    // copy all billing fields values to shipping fields
                    $("#billing :input").each(function (index, element) {
                        copyFieldValue(this);
                    });
                } else {
                    $("#shipping-address").removeClass("hidden");
                }

                $("#shipping :input")
                    .attr("readonly", shouldCopyFields)
                    .toggleClass("disabled", shouldCopyFields)
                    .trigger("change");

                // copy all billing fields values to shipping fields AGAIN
                // this is required when region app is enabled
                // as we can't guarantee the order fields are copied.
                // the region code could be copied before the country and when country
                // is changed, the region code field can be replaced by a select and
                // have options created. this way, we should copy values
                // before the `change` event trigged above and once again after
                // all fields get changed
                if (shouldCopyFields) {
                    $("#billing :input").each(function (index, element) {
                        copyFieldValue(this);
                    });
                }
            }

            function copyFieldValue(element) {
                if(!shouldCopyFields || !element)
                    return;
                var targetName = $(element).attr("id").split("-")[1];
                var $target = $("#id_shipping-" + targetName);
                $target.val(element.value);
                $target.trigger("change");
            }

            function activateCheckoutAddressCopy() {
                $("#id_shipping-country").attr("readonly", true);
                toggleAndCopyFields();
                $("#billing :input").on("input change", function (evt) {
                    copyFieldValue(evt.target);
                });
                $("#same_as_billing").on("change", toggleAndCopyFields);
            }
            activateCheckoutAddressCopy();

            // we detectec that a field could be replaced by any other input
            // in cases like regions module is injected
            // this way, we must attach the event again
            document.addEventListener("regionFieldInitialized", function (evt) {
                if ($(evt.detail.field).attr("name").indexOf("billing") >= 0) {
                    $(evt.detail.field).on("input change", function (evt) {
                        copyFieldValue(evt.target)
                    });
                }
            });
        });
    </script>
{% endmacro %}
